from subsetAndSorting import *

##########################---------FUNCTION 3--------####################################################

#function 3: compares the dataset to get motor turning values
#variable inputs: comparison (position) dataset, current dataset
#Outputs a data set with three columns: one column of bar number, one of motor direction, one of motor time
#subtracts the position columns from each other (assume already sorted)
#multiplies this by a constant value to get motor time (constant is TBD--a number based on how fast motor turns. make it a variable and use .1 for now)
#adds a column for motor direction--negative motor time means backward (=>1), positive means forward (=> 0)
#changes all motor time values to positive.  also make them all 3 digits! (e.g. 5 = 005)
#returns this 3 column database


def motorChanges (prevDataSet, currentDataSet, colToCompare):
    #colToCompare is a string ("position")

    #applying sortinDataSets function to make sure both are aligned correctly
    oldAligned = (sortingDataSets(prevDataSet, "bar").reset_index()).drop("index", 1)
    newAligned = (sortingDataSets(currentDataSet, "bar").reset_index()).drop("index", 1)
    col = oldAligned[colToCompare] 
    
    comparisonData1 = newAligned.sub(col, axis= 0) #substract the newAligned - oldAligned
    comparisonData3 = comparisonData1.drop("bar", 1)
    comparisonData3 = comparisonData1.drop("blink", 1)
    comparisonData2 = comparisonData3.drop("color", 1)
   
    comparisonData2["bar"] = newAligned["bar"] #storing "bar" for comparsinData2
    
    
    
    def getNewCol(x):
        #function to get the direction and motor time. 
        if x < 0:
            return 1, (round(abs(x)*1, 0)) #0.1 is the CONSTANT value we need, WILL CHANGE
            #1 represents forward
        else:
            return 0, (round(abs(x)*1, 0)) #0 represents backwards

    comparisonData2["direction"] , comparisonData2["motorTime"] = zip(*comparisonData2["position"].map(getNewCol))
    #adds the new two columns using the function zip
    
    comparisonData = comparisonData2.drop("position", 1)
    comparisonData["blink"] = newAligned["blink"]
    comparisonData["color"] = newAligned["color"]
    
    return comparisonData.dropna() #getting rid of the NaN values
    
#########################################################################################################
#toSend = motorChanges (currentData , subset([1], [1])[1], "position")
#print toSend
