from motorAndColorChanges import *
import sys
import serial
import time
PORT = "/dev/ttyACM1"


time.sleep(2)
ser = serial.Serial(PORT, 9600)


##########################---------FUNCTION 4--------####################################################
#function 4: completed before--send this dataset row by row to arduino!

#function use
#run function 1: store both datasets somewhere
#run function 2 for both the current position dataset and the new position dataset
#run function 3 on these two sorted datasets
#run function 4 to send the data
#replace the old current position dataset, with the new position dataset from #1



def beforeSendingData(t, chem, prevDataSet, colToCompare, rowNumber1, rowNumber2, motorsOrLights):
    #extracted from pandasToArduinoFunction. 
    #motorsOrLights is a list that contains ["m"] or ['l'] or ["m,"l"]
    
    bar_position = subset(t, chem)[1] #first function
    toSend = motorChanges (prevDataSet , bar_position, colToCompare) #third function
    prevDataSet = bar_position.reset_index(level=None, drop=False, inplace=False, col_level=0, col_fill='')
    #updating the previousData since we already performed an action
        

    selectedRow = toSend.ix[rowNumber1:rowNumber2,:]
    #changes the panda DataFrame type to string type and selects a range of rows
    #print "selectedRow: ", selectedRow
    #cleaning the data to be sent, so only numbers are sent
    toString = selectedRow.to_string(buf=None, columns=None, col_space=None, colSpace=None, header=False, index=False, na_rep='NaN', formatters=None, float_format=None, sparsify=None, index_names=False, justify=None, line_width=None, max_rows=None, max_cols=None, show_dimensions=False)
    cleanString1 = toString.replace("'", "")
    cleanString2 = cleanString1.replace(" ", "")
    cleanString = cleanString2.split()

    motorList = []
    blinkList = []
    
    for oneData in cleanString:
        print "oneData: ", oneData

        if len(oneData) == 8:
        
            motorDigits, blinkDigits =oneData[:5], oneData[5:]

            motorData = '2'+motorDigits

            motorList.append(motorData)
            

            
            lightDigit = oneData[-1] #4, 5, or 6
            
                
            if lightDigit == "4": #red led
                blinkData = "1"+blinkDigits[:2]+"100"
                    
            elif lightDigit == "5": #green led
                blinkData = "1"+blinkDigits[:2]+"010"
                    
            elif lightDigit == "6": #blue led
                blinkData = "1"+blinkDigits[:2]+"001"
            #lightData = 112345?

            blinkList.append(blinkData)

        else:
            motorData= "200000"
            motorList.append(motorData)
            blinkData = "100000"
            blinkList.append(blinkData)

    print "motorList: ", motorList
    print "blinkList: ", blinkList

    if motorsOrLights == ["m"]:
        return motorList , prevDataSet
    
    elif motorsOrLights == ["l"]:
        return  blinkList, prevDataSet

    elif motorsOrLights == ["m", "l"]:
        return  motorList, blinkList, prevDataSet

    else:
        return prevDataSet

    #prevDataSet = beforeSendingData(...)[-1] ALWAYS!!!,
                    #We want to update prevDataSet after we compare values
    

#selectedData = beforeSendingData([1], [1], currentData, "position", 0, 0, ["m", "l"])
#print len(selectedData)
    
#returns prevDataSet and numbers to sent for motors or lights
#dataSent(selectedData = beforeSendingData(t, chem, prevDataSet, colToCompare, rowNumber1, rowNumber2, motorsOrLights)

def dataSent(selectedData):
    
    dataToSend = selectedData[:-1]
    
    for listToSend in dataToSend: #i is either motorList or blinkList, or both
        
        while len(listToSend)>0:
            #time.sleep(10)
            sending = listToSend[0]
            ser.write(sending)
            ser.write("\r")
            
            print "Value written to port: '%s': ", sending
        
            if sending == None:
                print "Value written to port: FAILED "
            
            listToSend.remove(sending)
        


    ####################################

            
    #this needs to match what lineAvailable is waiting for in the arduino code (\r and \n are options)
        
     
    #ser.close()
    #print "Bytes Written to port:", written
    #print "Value written to port: '%s'"%cleanString
            

    #LP: If we do this serial read we get stuck! I think there is nothing to read yet, and if we do read we miss stuff later       
    #print ser.read()
    #print "HANG UP HERE" 
    #ser.close()

    if __name__ == '__dataSent__':
        args = sys.argv
        try:
            dataSent(args[1])
        except IndexError:
            dataSent()

   
#print dataSent()
    #return main(), prevDataSet #writes cleanString in arduino and stores prevDataSet to be used again.
    #return prevDataSet #writes cleanString in arduino and stores prevDa
###########################################


#print sendingData([1], [1], currentData, "position", 0, 0)
# values written to the port: 115, 213, 318, 411 (/bar, direction, time/)
