#pandas stuff
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt


##########################---------FUNCTION 1--------##################################################
global fullData
global currentData

fullData = pd.read_csv('testData.csv')

currentData = pd.read_csv('neutralPosition.csv')



#function 1: subsets the full database
#has two variable inputs: the time(s) (1 and/or 2) and chemical(s) (A and/or B) that we want 
#subset the full database base based on these input
#returns the new subsetted database
#also returns the position dataset we'll need to use--just bar column and position column
#(unpacking)

def subset(t, chem):



    #chem and t are LISTS

    time = t 
    chemical = chem
    blink = range(11,21)
    color = [5,6,7]
    bar = range(100)
    for i in range(11):
        bar.remove(i) #range is always a number less because it includes 0.
    position = range(101)
    position.remove(0)
    dataValues = {'bar': bar, 'time': t, 'chemical': chem, 'position': position, 'blink': blink, 'color': color}

    #row_mask = fullData.isin(dataValues).all(1)
    row_mask = fullData.query('time == t and chemical== chem')
    #print "row_mask: ", row_mask
    #newData1= fullData[row_mask]
    #print "newData1", newData1 
    
    ##############   End of first part of the code  ##############

    #newData2 = fullData[row_mask] #same as newData1, but just with a different name
    newData2 = row_mask
    newData2 = newData2.drop('time', 1)
    newData2 = newData2.drop('chemical', 1)
    
    #############


    return row_mask, newData2        #example: subset([1], [1])

###########################################################################################################


##########################---------FUNCTION 2--------####################################################

#bar_position = subset([1], [1])[1] #just to test it!!! REMOVE IT 

#function 2: sort the datasets
#We need to confirm the two datasets are organized the same way before subtracting position values
#Inputs: a data set, and a column name
#Outputs a dataset sorted by that column name
#(i.e. I can put in a dataset, sort by "bar" column, and get it back organized low to high


def sortingDataSets (dataSet, colName):
    
    return dataSet.sort_index(axis=0, by= colName, ascending=True, inplace=False, kind='quicksort')

    #example: sortingDataSets(bar_position, "position")

#########################################################################################################
